//+------------------------------------------------------------------+
//|                                                         2way.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <stdlib.mqh>

//--- input parameters
extern double    FixLot=0.01;
extern double    Multi=2.0;
extern int       Profit=20;
extern int       Loss=20;
extern int       Slippage=1;
extern bool      FirstBuy=true;
extern int       Magic=1991;


  
   int 
   Ticket,
   OrderTip=-1,   //      
   OrderLot=-1;   //     
   
   double
   NextOrderLot;
   
   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   
   if (FirstBuy == true)
     {
  
    Ticket=OrderSend(Symbol(),  // 
      OP_BUY,   //  
      FixLot,  //  
      NormalizeDouble(Ask,Digits), //  
      Slippage, // 
      NormalizeDouble(Ask,Digits) - New_Stop(Loss)*Point, //
      NormalizeDouble(Ask,Digits) + New_Stop(Profit)*Point, //  
      "2WayProfit", //
      Magic,  // 
      Lime ); // 
     
      //   
       if (Ticket < 0)                        
           {
            Alert(": ", ErrorDescription(GetLastError()));
            return (0);
           }
      }
      
    else 
      
      if (FirstBuy!=true)
       {
        Ticket=OrderSend(Symbol(),  // 
      OP_SELL,   //  
      FixLot,  //  
      NormalizeDouble(Bid,Digits), //  
      Slippage, // 
      NormalizeDouble(Bid,Digits) + New_Stop(Loss)*Point, //
      NormalizeDouble(Bid,Digits) - New_Stop(Profit)*Point, //  
      "2WayProfit", //
      Magic,  // 
      Red ); // 
     
      //   
       if (Ticket < 0)                        
           {
            Alert(": ", ErrorDescription(GetLastError()));
            return (0);
           }
      }
  
  return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  int
  
  
  Tip=-1,
  Total;
  
  double

  

  
 
  Lts,                             
  Min_Lot,                         
  Step,                            
  Free,                            
  One_Lot,
    
  Price,
  SL,
  TP,
  Lot,
  
  BuyPrice,    //      
  SellPrice;  

 bool
  Opn_B=false,
  Opn_S=false;

  
  
  Comment( "    ",  MODE_STOPLEVEL,  " () " );
 
 
   
 
 
// ----------------------------  ר   -------------------------------





//  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symbol(),MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symbol(),MODE_LOTSTEP);       //   
 
   
   if (FixLot > Free)                      //   .
     {
      Alert("     ", FixLot ," ");
      return;                                   //   start()
     }
  
 
  
// ------------------------------ ר  -----------------------------------

  Total = 0;
  
  for (int i=1; i<= OrdersTotal(); i++)
    {
     if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symbol() || OrderMagicNumber() != Magic ||  //   
           OrderType() > 1 )continue;        // , ,    -- 
           Total++ ;
          if (Total > 1)
          {
           Print("    .      ");
           return;
           }
         }
       }




//--------------------------------     -----------------------------

// -   http://forum.mql4.com/ru/5370

datetime OrderOpnTime;
double   LotStep=MarketInfo(Symbol(), MODE_LOTSTEP);
double   MinLot=MarketInfo(Symbol(), MODE_MINLOT);
int      History=HistoryTotal(), j, k, Next;
 
for (j=0; j<History; j++) {
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) 
   {
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
     {
      if (OrderType()==OP_BUY || OrderType()==OP_SELL)
       {
        if (OrderOpnTime<OrderOpenTime())
         {
          OrderOpnTime=OrderOpenTime();
          Next=j;
        }
      }
    }
  }
}
if (OrderSelect(Next, SELECT_BY_POS, MODE_HISTORY))
 {
  if ( OrderProfit()<0 && OrderType() == OP_BUY  )
    {
     NextOrderLot=2*OrderLots();
     OrderTip = OP_SELL;
     Opn_B=true;
     }
    
     else 
     
        if ( OrderProfit()<0 && OrderType() == OP_SELL  )
          {
           NextOrderLot=2*OrderLots();
           OrderTip = OP_BUY;
           Opn_S=true;
           }
           
       else NextOrderLot=FixLot;

 }











// ------------------------------       ----------------



        if (Total==0 && Opn_B==true )             
        {                                       
         RefreshRates();                        
         SL=Ask - New_Stop(Loss)*Point;     
         TP=Ask + New_Stop(Profit)*Point;   
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symbol(), OrderTip , NextOrderLot, NormalizeDouble(Ask,Digits),2,SL,TP,"2WayProfit", Magic, Lime );// Buy
         
         if (Ticket < 0)                        //  :)
           {
            Alert(": ", ErrorDescription(GetLastError()));
            return (0);
           }
         return;                                //   start()
        }
      
         if (Total==0 && Opn_S == true)              
        {                                       
         RefreshRates();                        
         SL=Bid + New_Stop(Loss)*Point;     
         TP=Bid - New_Stop(Profit)*Point;
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symbol(),OrderTip, NextOrderLot,NormalizeDouble(Bid,Digits),2,SL,TP,"2WayProfit", Magic, DarkOrange );// Buy
         if (Ticket < 0)                        //  :)
           {
            Alert(": ", ErrorDescription(GetLastError()));
            return (0);
           }
         return;                                //   start()
        }
  
     }


//+------------------------------------------------------------------+
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symbol(),MODE_STOPLEVEL);// . 
   if (Parametr < Min_Dist)                     //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }